/*
 * Copyright (c) 2003 Benedikt Meurer (benedikt.meurer@unix-ag.uni-siegen.de)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __XFPRINTER_H__
#define __XFPRINTER_H__

#include <gdk/gdkx.h>
#include <glib.h>

typedef struct _XfPrinter XfPrinter;
struct _XfPrinter
{
	gchar		*alias;
	gchar		*name;
	gboolean	postscript;
};

extern XfPrinter	*xfprinter_new(const gchar *, const gchar *);
extern XfPrinter	*xfprinter_new_ps(const gchar *, const gchar *);
extern void		xfprinter_free(XfPrinter *);
extern void		xfprinter_copy(XfPrinter *, const XfPrinter *);
extern XfPrinter	*xfprinter_dup(const XfPrinter *);
extern GdkPixbuf	*xfprinter_icon(XfPrinter *, gboolean);

extern void		xfprinter_set_alias(XfPrinter *, const gchar *);
extern void		xfprinter_set_name(XfPrinter *, const gchar *);
extern void		xfprinter_set_postscript(XfPrinter *, gboolean);

#endif	/* !__XFPRINTER_H__ */
